//--
//--    Copyright  1994,1995 Uluwatu Software.  All rights reserved.
//--
//--	Author:  Mark Salsbery (CIS 71603,3643)
//--
//-- 	Feel free to use this code any way you wish (at your own risk,
//--	  of course).
//--

#if !defined(__ULU_UDOCMGR_H)
#define __ULU_UDOCMGR_H


#define DTOPENSAVEFLAGSMASK (dtReadOnly |			\
							 dtOverwritePrompt |	\
							 dtHideReadOnly |		\
							 dtPathMustExist |		\
							 dtFileMustExist |		\
							 dtCreatePrompt |		\
							 dtNoReadOnly |			\
							 dtNoTestCreate |		\
							 OFN_ALLOWMULTISELECT |	\
							 OFN_NOCHANGEDIR)


class TMyDocument : public TDocument
{
	private:
	protected:
	public:
		TMyDocument(TDocument *pPar = 0) : TDocument(pPar)  {}
		virtual ~TMyDocument()  {}

};

class TCustomDocManager : public TDocManager
{
	private:
	protected:
		// TDocManager protected overrides
		virtual int SelectDocPath(TDocTemplate **tpllist,
									  int tplcount, char far *path,
											   int buflen, long flags,
														  bool save = FALSE);
	public:
		TCustomDocManager(int mode);
		virtual ~TCustomDocManager();
};


class TDVFileOpenDialog : public TCustomFileOpenDialog
{
	private:
	protected:
		long lOriginalFlags;
		TDocTemplate **ppTplList;
		int nCurTplIndex;
		// Control interface objects
		TComboBox *pFileTypesCmbBox;
		TCheckBox *pReadOnlyChkBox;
		// TCustomFileOpenDialog over-rides
		virtual void SetupWindow();
		// Message Handlers
		void EvPaint();
		void FileTypesBoxSelChg();
		// Misc functions
		void Update();
	public:
		TDVFileOpenDialog(long lOrigFlags, TDocTemplate **ppTmplList,
										   TWindow *pParent, TData &data,
										  LPCSTR pTitle, TModule *pMod = 0);
		virtual ~TDVFileOpenDialog();

		OPENFILENAME *GetOFNPtr()  {return &ofn;}

	DECLARE_RESPONSE_TABLE(TDVFileOpenDialog);
};


class TDVFileSaveDialog : public TCustomFileSaveDialog
{
	private:
	protected:
		long lOriginalFlags;
		TDocTemplate **ppTplList;
		int nCurTplIndex;
		// Control interface objects
		TComboBox *pFileTypesCmbBox;
		TCheckBox *pReadOnlyChkBox;
		// TCustomFileSaveDialog over-rides
		virtual void SetupWindow();
		// Message Handlers
		void EvPaint();
		void FileTypesBoxSelChg();
		// Misc functions
		void Update();
	public:
		TDVFileSaveDialog(long lOrigFlags, TDocTemplate **ppTmplList,
										  TWindow *pParent, TData &data,
										  LPCSTR pTitle, TModule *pMod = 0);
		virtual ~TDVFileSaveDialog();

		OPENFILENAME *GetOFNPtr()  {return &ofn;}

	DECLARE_RESPONSE_TABLE(TDVFileSaveDialog);
};



#endif  // #if !defined(__ULU_UDOCMGR_H)


